// XOR.java                                         MM 2014
// Model

// import java.io.*;                          // Datenstreams

/**
 * Codiert einen Bytecode mittels einem XOR-Codierer.
 */

public class XOR
{
/* ----------------------------------------------------- */
                                                // coreData
/**
 * Geladener Code
 */
  private Code geladen;

/**
 * Codierter Code.
 */
  private Code codiert;

/**
 * Code wurde bereits codiert.
 */
  private boolean istCodiert;

/* ----------------------------------------------------- */
                                             // Konstruktor
/**
 * Konstruktor, setzt Modell auf Startwerte.
 */
  public XOR()
  {
    reset();
  }

/* ----------------------------------------------------- */
                                        // getData-Methoden
/**
 * Lesen des geladenen Codes.
 * @return Originalcode
 */
  public Code getGeladen()
  {
    return geladen;
  }

/**
 * Lesen des codierten Codes.
 * @return codierter Code
 */
  public Code getCodiert()
  {
    return codiert;
  }

/**
 * Original wurde bereits codiert.
 * @return true, falls Original codiert
 */
  public boolean istCodiert()
  {
    return istCodiert;
  }

/* ----------------------------------------------------- */
                                        // service-Methoden
/**
 * Zuruecksetzen des Modells.
 */
  public void reset()
  {
    geladen = new Code();
    codiert = new Code();
    istCodiert = false;
  }

/**
 * Lesen eines Codes von einer Datei.
 * @param dateiName Name der Codedatei
 */
  public void liesAusDatei( String dateiName)
    throws Exception
  {
    istCodiert = false;
    geladen = new Code( dateiName);
    codiert = new Code();
  }

/**
 * Speichern eines Codes in eine Datei.
 * @param dateiName Name der Codedatei
 */
  public void schreibeInDatei( String dateiName)
    throws Exception
  {
    Code code
    = (istCodiert) ? codiert : geladen;
    code.schreibeInDatei( dateiName);
  }

/**
 * Codieren mit gegebenen Schluessel.
 * @param schluessel Codeschluessel
 */
  public void codieren( int schluessel)
  {
    Codierer c = new XORCodierer( geladen, schluessel);
    codiert = c.codieren();
    istCodiert = true;
  }
}
